###  VERSIÓN MANUAL REVISADA




    ## Asignamos los coeficientes en la función objetivo (puede haber varios objetivos)
    ## y añadimos los vectores correspondentes a las variables de holgura y/o artificiales a 
    ## la matriz A

ch   =  matrix(QQ,1,0,[] )
ct   =  matrix(QQ,1,0,[] )

ccx  =  matrix(QQ,1,0,[] )
cct  =  matrix(QQ,1,0,[] )
Cero =  matrix(QQ,1,1,[0] )
Uno  =  matrix(QQ,1,1,[1] )


FASEI=var('FI', latex_name='\\ \\ \\ Fase\\ I')
FASEII=var('FII', latex_name='\\ \\ \\ Fase\\ II')

salto=var('salto', latex_name='')
raya=var('ry', latex_name='===================================')
dual=var('dual', latex_name='\\texttt{El dual es:}')


##############################################################################
####### Usando el paquete de programación lineal Pinteractive de Sage ########
##############################################################################
signos=[]
for i in range(m):
    if h[0,i] == -1:
        signos.append(">=")
    elif h[0,i] == 1:
        signos.append("<=")
    elif h[0,i] == 0:
        signos.append("==")
        
var_nam = []
for i in range(n):
    k=i+1
    var_nam.append('x_%s' %k)
        
PPL = InteractiveLPProblem(A, b, c, var_nam,   
constraint_type=signos, variable_type=">=", problem_type=tipo) 

##############################################################################



B    = var('B', latex_name='Basic')
rhs  = var('rhs', latex_name='b')
rhs1 = var('rhs1', latex_name='b_1')
rhs2 = var('rhs2', latex_name='b_2')
rhs3 = var('rhs3', latex_name='b_3')

B    = matrix(SR,1,1, B)  
rhs  = matrix(SR,1,1, rhs) 
rhs1 = matrix(SR,1,1, rhs1) 
rhs2 = matrix(SR,1,1, rhs2) 
rhs3 = matrix(SR,1,1, rhs3) 

Z   = var('Z', latex_name='Z_{ind}')
Z1p = var('Z1p', latex_name='Z{1p}')
Z2p = var('Z2p', latex_name='Z{2p}')
Z3p = var('Z3p', latex_name='Z{3p}')

Z   = matrix(SR,1,1, Z)
Z1p = matrix(SR,1,1, Z1p)
Z2p = matrix(SR,1,1, Z2p)
Z3p = matrix(SR,1,1, Z3p)

W = var('W', latex_name='W_{ind}')
W = matrix(SR,1,1, W) 


 
# Variables en el problema 

I=matrix.identity(QQ,m)
BM1=I

xi = var('x', n=n+3, latex_name="x"); #xi._latex_()
X = matrix(SR, xi)
XX = X[0,[1 .. (n)]]  

si = var('s', n=3*m+1, latex_name="\\color{green}{s}"); #xi._latex_()
S = matrix(SR, si)
SS = S[0,[1 .. (m)]]

ti = var('t', n=m+1, latex_name="\\color{red}{t}") 
T = matrix(SR, ti)
TT = T[0,[1 .. (m)]]


    
for i in range(n):
    ccx=block_matrix([ [ccx, Cero ] ])

nv=n;
tt=[];
idpos=n-1;
colbas=[0 .. (m-1)]

signos=[]
IS=matrix(QQ,m,0,[])
e=0  # Eliminemos las variables introducidas en SS que no son variables de holgura
for i in range(m):
    if h[0,i] == -1:
        IS=block_matrix([ [ IS,-I[:,i] ]])
        ch=block_matrix([ [ch, Cero ] ])
        tt.append(1)
        idpos=idpos+1
        nv=nv+1
        signos.append(">=")
    elif h[0,i] == 1:
        IS=block_matrix([[IS,I[:,i]]])
        ch=block_matrix([[ch, Cero ]])
        colbas[i]=idpos+1
        idpos=idpos+1
        tt.append(0)
        nv=nv+1
        signos.append("<=")
    elif h[0,i] == 0:
        tt.append(1)
        signos.append("==")
        i=i-e
        SS=SS[[0],[0 .. i-1,i+1 .. m-1-e]]
        e=e+1 

t=matrix(ZZ,1,m,tt);    


nvar=nv   # nvar es el número de variables en el problema y 
          # nv será el del problema de la fase I 


e=0
nart=0 ## Llevará la cuenta del número de variables artificiales en el problema
       ## Eliminemos las variables introducidas en TT que no son variables artificiales.
       ## Agregamos a la matriz A los vectores columnas de las variables artificiales
       ## Terminamos de crear el vector con las posiciones de las variables básicas originales (holgura + artificiales)

IA=matrix(QQ,m,0,[])
for i in range(m):
    if t[0,i] == 0:
        i=i-e
        TT=TT[[0],[0 .. i-1,i+1 .. m-1-e]]
        e=e+1
    elif t[0,i] == 1:
        IA=block_matrix([[IA,I[:,i]]])
        ct=block_matrix([[ct, Cero ]])
        cct=block_matrix([[cct, Uno ]])
        nv=nv+1
        nart=nart+1
        colbas[i]=idpos+1
        idpos=idpos+1

        
A = block_matrix([[A,IS]])  #Matriz de los coeficientes
AI= block_matrix([[A,IA]])  #matriz de los coeficientes de la fase I



if nart > 0:
    Art=1
elif nart == 0:
    Art=0
        
cols  = [i for i in range(nvar) ]    #columnas en la matriz A 
colsI = [i for i in range(nv)   ]    #columnas en la matriz AI

vars = block_matrix([ [XX,SS] ])  # nombres de todas las variables
varsI= block_matrix([ [XX,SS,TT] ])  # nombres de todas las variables en la Fase I

cv  = block_matrix([ [c,ch] ])
cvI = block_matrix([ [ccx,ch,cct] ])



def cuadro(AA,bb): 
    global Cuadro, colbas, A, b, BM1, varsB, varsBf
    
    if Art==1:
        variables=varsI
        cB=cvI[:,colbas]
        cbar=cvI-cB*AA
        Fobj=cB*bb 
        varsB=variables[:,colbas]
        varsB=column_matrix(SR,varsB)  
    if Art==0: 
        variables=vars
        cB=cv[:, colbas ] 
        cbar=cv-cB*AA
        Fobj=cB*bb
        varsB=variables[:,colbas]
        varsB=column_matrix(SR,varsB)
        
    Cuadro=block_matrix([
        [B,variables,rhs], 
        [varsB,AA,bb],
        [Z,cbar,Fobj] 
    ])   
                                           
    return Cuadro


cuadro(AI,b)

show(ry)
show(ry)
show(PPL)
show(PPL.optimal_value())
show(PPL.optimal_solution())
show(ry)


show(salto)
show(ry)

show(Cuadro)


    

def cuadroR(BM1,bb):
    global A, b, colbas, CuadroR, varsB, cbar, varsBf
    
    if Art==1:
        variables=varsI
        cB=cvI[:,colbas]
        piB=cB*BM1
        cbar=cvI-piB*AI
        Vobj=piB*b 
        varsB=variables[:,colbas]
        varsB=column_matrix(SR,varsB)  
        varsBf=variables[:,colbas]
        Fobj = var('WPI', latex_name='\\pi_B')
        Fobj = matrix(SR,1,1, Fobj) 

    if Art==0:
        variables=vars
        cB=cv[:,colbas]
        piB=cB*BM1
        cbar=cv-piB*A
        Vobj=piB*b
        varsB=variables[:,colbas]
        varsB=column_matrix(SR,varsB)  
        varsBf=variables[:,colbas]
        Fobj = var('ZPI', latex_name='\\pi_B')
        Fobj = matrix(SR,1,1, Fobj) 
    
    CuadroR=block_matrix([
        [B,varsBf,rhs],
        [varsB,BM1,bb],
        [Fobj,piB,Vobj]
    ])

    return CuadroR

cuadroR(BM1,b)

show(CuadroR)

print('Fila Indicadora')
show(block_matrix([[vars],[cbar]]))
print('      ')    

def fInd(Cuadro):
    fInd=Cuadro[m+1,[1..nv]]
    return fInd

def matrA(Cuadro):
    matrA=Cuadro[[1..m],[1..nv]]
    return matrA

def vectb(Cuadro):
    vectb=Cuadro[[1..m],[nv+1]]
    return vectb

mm=m
def faseII(nnArt,L): ## nnArt es el número de variables artificiales en la base al final de la fase I
                     ## L es un vector con la posición de dichas variables señaladas con un 1
    global BM1,cols,colbas,AII,bII,Art, A,b, varsB, m, mm  #,P, Cuadro,vars, Z,vars,cbar,cv,nv,nart

    if nnArt==0: 
        Art=0
        AII=BM1*A
        bII=BM1*b
        Cuadro=cuadro(AII,bII)
        show(ry)
        show(FASEII)
        show(ry)
        show(Cuadro)
    
    if nnArt!=0:
        ee=0
        for i in range(m):
            if L[i]==1:
                del colbas[i-ee]
                A=A[[0..i-1-ee,i+1-ee..m-1-ee],:]
                b=b[[0..i-1-ee,i+1-ee..m-1-ee],:]
                BM1=BM1[[0..i-1-ee,i+1-ee..m-1-ee],[0..i-1-ee,i+1-ee..m-1-ee]]
                ee=ee+1
                mm=mm-1
        
        Art=0
        AII=BM1*A
        bII=BM1*b
        Cuadro=cuadro(AII,bII)
        show(ry)
        show(FASEII)
        show(ry)
        show(Cuadro)   
    m=mm
    return


def pivot(l,k):
    global BM1, A_k, A
    A_k=BM1*A[:,k-1]
    P=matrix.identity(QQ,len(A_k.column(0)))
    for i in range(len(A_k.column(0))):
        if i==l-1:
            P[i,l-1]=1/A_k[l-1,0] 
        else:
            P[i,l-1]=-A_k[i,0]/A_k[l-1,0]
    return P


def cambio(l,k):
    global varsB,BM1,P,Art,colbas,cbar,varsB,varsBf, A, b

    P=pivot(l,k)
    BM1=P*BM1
    colbas[l-1]=cols[k-1]
    bb=BM1*b
    
    if Art==1:
        variables=varsI
        varsB=variables[:,colbas]
        varsB=column_matrix(SR,varsB) 
        varsBf=variables[:,colbas]

    if Art==0:
        variables=vars
        varsB=variables[:,colbas]
        varsB=column_matrix(SR,varsB) 
        varsBf=variables[:,colbas]
    
    print('      ')
    print('            Matriz Inversa')
    
    CuadroR=cuadroR(BM1,bb)
    show(CuadroR)

    filaindicadora=block_matrix([[variables],[cbar]])
    print('Fila Indicadora')
    show(filaindicadora)
    print('      ')

    return


def cocientes(k):
    global BM1, A_k, A, b, varsB, varsBf
    bb=BM1*b
    A_k=BM1*A[:,k-1]
    v=matrix(RR,len(A_k.column(0)),1,0)
    v=matrix(SR,v)   
    for i in range(len(A_k.column(0))):
        if A_k[i,0]<=0:
           v[i,:]='NO'
        else:
           v[i,:]= N(bb[i]/A_k[i,0],digits=5)
    CuadroRR=block_matrix([[B,rhs],[varsB,bb]])
    Ent = var('Ent', latex_name='Col\\ Entr')
    Ent = matrix(SR,1,1, Ent) 
    Coc = var('Coc', latex_name='Cocientes')
    Coc = matrix(SR,1,1, Coc) 
    CuadroRRR=block_matrix([[Ent,Coc],[A_k,v]])
    CuadroRRRR=block_matrix([[CuadroRR,CuadroRRR]])
    show(CuadroRRRR)
    return 



def cocientesA(k):
    global A, b, BM1, Ak
    vs=-1
    v=infinity
    bb=BM1*b
    Ak=BM1*A[:,k-1]
    for i in range(len(A.column(0))):
        if Ak[i,0]>0:
            vv=bb[i]/Ak[i,0]
            if vv[0][0]< v:
                v=vv[0][0]
                vs=i
    return vs
    
    
def cocientesD(l):
    global A,cbar,A_l, varsB
    A_l=BM1[l-1,:]*A
    v=matrix(RR,1,len(cbar.row(0)),0)
    v=matrix(SR,v)
    for j in range(len(cbar.row(0))):
        if A_l[0,j]>=0:
            v[:,j]='NO'
        else:
            v[:,j]= N(cbar[0,j]/A_l[0,j],digits=5)
    Coc = var('Coc', latex_name='Cocientes')
    Coc = matrix(SR,1,1, Coc) 
    CuadroSS=block_matrix([[B, vars],[varsB[l-1,0],A_l],[Z, cbar],[Coc,v]])
    show(CuadroSS)
    return 





def cuadroI():
    show(cuadro(BM1*AI, BM1*b))
    return

def cuadroII():
    show(cuadro(BM1*A, BM1*b))
    return


def BM():
    global A
    A[:,colbas]
    return    
   

    
def añade(v,R):
    global BM1, A, b, m,n,vars,varsB,zb, Cuadro, cols, colbas, nvar, cv, S, cbar

    #vde00=matrix.identity(m)[m-1,:]-matrix.identity(m)[m-1,:]
    vB=v[:,colbas]
    pivB= -vB*BM1 
    bsig=pivB*b+R
    bb=BM1*b 
    AA=BM1*A
    vN=-vB*AA+v

    BM11=block_matrix([[BM1],[pivB]])
    vdeide=matrix.identity(m+1)[:,m];
    BM1=block_matrix([[BM11,vdeide]], subdivide=false)
    

    bb=block_matrix([[bb],[bsig]],subdivide=false); #vector de la derecha
    b=block_matrix([[b],[R]],subdivide=false); #vector de la derecha original con el añadido
    
    AA=block_matrix([[AA],[vN]], subdivide=false);
    AA=block_matrix([[AA,vdeide]], subdivide=false);
    A=block_matrix([[A],[v]])   
    A=block_matrix([[A,vdeide]])
    cols.append(nvar)
    colbas.append(nvar)

    zo=matrix(QQ,1,1,[0])
    cv=block_matrix([[cv,zo]])
         
    cB=cv[:, colbas ] 
    cbar=cv-cB*AA
         
    vars=block_matrix([[vars, S[0,m+1]]], subdivide=false)
    
    
    varsB=vars[:,colbas]
    varsB=column_matrix(SR,varsB)
    
    zb=cB*bb
    
    
    
    Cuadro=block_matrix([[B,vars,rhs] , [varsB,AA,bb],[Z,cbar,zb] ] )   
    
    m=m+1;
    nvar=nvar+1;
    show(Cuadro);  
    return



def param1b(b1p):
    global A,b,varsB,rhs,rhs1,cbar,zb, Cuadro, colbas, cv
    cB=cv[:, colbas ] 
    b1=BM1*b1p;zb1=cB*b1
    AA=BM1*A
    bb=BM1*b
    bb=block_matrix([ [bb, b1] ] , subdivide=False)
    rhs=block_matrix([[rhs,rhs1]], subdivide=False)
    zb=block_matrix([[zb,zb1]], subdivide=False)
    Cuadro=block_matrix([[B,vars,rhs],[varsB,AA,bb],[Z,cbar,zb] ] )
    show(Cuadro)
    
def param2b(b1p,b2p):
    global A,b,varsB,rhs,rhs1,cbar,zb, Cuadro, colbas, cv
    cB=cv[:, colbas ] 
    b1=BM1*b1p;zb1=cB*b1
    b2=BM1*b2p;zb2=cB*b2
    AA=BM1*A
    bb=BM1*b
    bb=block_matrix([ [bb, b1, b2] ] , subdivide=False)
    rhs=block_matrix([[rhs,rhs1,rhs2]], subdivide=False)
    zb=block_matrix([[zb,zb1,zb2]], subdivide=False)
    Cuadro=block_matrix([[B,vars,rhs],[varsB,AA,bb],[Z,cbar,zb] ] )
    show(Cuadro)

def param1c(c1p):
    global A,b,varsB,rhs,cbar,zb, Cuadro, c1bar, z1b, cB, cv,Z1p, colbas,Z
    c1v=block_matrix([[c1p,ch]])
    cv=block_matrix([[cv], [c1v] ])
    cB=cv[:,colbas]
    AA=BM1*A
    bb=BM1*b
    cbar=cv-cB*AA
    zb=cB*bb
    Z=block_matrix([[Z],[Z1p]])
    Cuadro=block_matrix([[B,vars,rhs] , [varsB,AA,bb],[Z,cbar,zb] ] )   
    show(Cuadro)
    
def param2c(c1p,c2p):
    global A,b,varsB,rhs,cbar,zb, Cuadro, c1bar, z1b, cB, cv,Z1p, colbas,Z
    c1v=block_matrix([[c1p,ch]])
    c2v=block_matrix([[c2p,ch]])    
    cv=block_matrix([[cv], [c1v], [c2v] ])
    cB=cv[:,colbas]
    AA=BM1*A
    bb=BM1*b
    cbar=cv-cB*AA
    zb=cB*bb
    Z=block_matrix([[Z],[Z1p],[Z2p]])
    Cuadro=block_matrix([[B,vars,rhs] , [varsB,AA,bb],[Z,cbar,zb] ] )   
    show(Cuadro)
